program XSource;
(********************************)
(* XSource: Collision Detection *)
(********************************)
(* XProger@list.ru              *)
(* http://XProger.mirgames.ru   *)
(********************************)
uses
  Windows,
  Messages,
  OpenGL,
  l_camera in 'l_camera.pas',
  l_game in 'l_game.pas',
  l_gl in 'l_gl.pas',
  l_input in 'l_input.pas',
  l_map in 'l_map.pas',
  l_math in 'l_math.pas',
  l_player in 'l_player.pas',
  l_utils in 'l_utils.pas';

var
 Time, Time_Delta, Time_Old : DWORD;

(*********************)
(*         *)
(*********************)
function WndProc(hwnd: DWORD; message: UINT; wParam: Longint; lParam: LongInt): LongInt; stdcall;
begin
 Case message of
  WM_QUERYENDSESSION, WM_CLOSE:
   begin
   Game_Free;
   glClose;
   isQuit := true;
   end;

  WM_ACTIVATEAPP:
   if Initialized then
    if LOWORD(wParam) = WA_ACTIVE then
     begin
     ResetKeys;
     glActive := true;
     ShowWindow(Handle, SW_SHOWNORMAL);
     if glFullScreen then
      glDisplay(glWidth, glHeight, glBPP, glFreq);
     Time_Old := GetTimer;
     end
    else
     begin
     ResetKeys;
     glActive := false;
     ShowWindow(Handle, SW_SHOWMINIMIZED);
     if glFullScreen then
      ChangeDisplaySettings(_devicemodeA(nil^), CDS_FULLSCREEN);
     end;

  WM_KEYDOWN   : KeyOnDown(wParam);
  WM_KEYUP     : KeyOnUp(wParam);
  WM_MOUSEMOVE : MouseDelta(LOWORD(lParam), HIWORD(lParam));
 end;
Result := DefWindowProc(hwnd, message, wParam, lParam);
end;

function CreateWindow: HWND;
var
 wndclass : WNDCLASSEX;
begin
ZeroMemory(@wndclass, sizeof(WNDCLASSEX));
with wndclass do
 begin
 cbSize        := sizeof(WNDCLASSEX);
 style         := CS_HREDRAW or CS_VREDRAW or CS_OWNDC;
 lpfnWndProc   := @WndProc;
 cbClsExtra    := 0;
 cbWndExtra    := 0;
 hInstance     := 0;
 hIcon         := LoadIcon (hInstance, 'MAINICON');
 hCursor       := LoadCursor (0, IDC_ARROW);
 hbrBackground := HBRUSH(GetStockObject(BLACK_BRUSH));
 lpszMenuName  := nil;
 lpszClassName := 'XSource_Wnd';
 end;
RegisterClassEx(wndclass);

Result := CreateWindowEx(WS_EX_TOPMOST,
                         'XSource_Wnd',
                         'XSource',
                         WS_POPUP,
                         0, 0,
                         glWidth, glHeight,
			                   0, 0, 0, nil);

SendMessage(Result, WM_SETICON, 1, LoadIcon(hInstance, 'MAINICON'));
end;

var
 i    : integer;
 flag : boolean;
 msg  : TMSG;
begin
Handle := CreateWindow;
if (Handle = 0) or not glInit then
 Exit;
Game_Init;
SetForegroundWindow(Handle);
ShowWindow(Handle, SW_SHOW);
ShowCursor(false);
UpdateWindow(Handle);
SetCursorPos(glWidth div 2, glHeight div 2);
if glFullScreen then
 glDisplay(glWidth, glHeight, glBPP, glFreq);

Initialized := true;

Time_Old := GetTimer;
while not isQuit do
 begin
 while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do
  begin
  TranslateMessage(msg);
  DispatchMessage(msg);
  if isQuit then
   Exit;
  end;

 isQuit := KeyDown(VK_ESCAPE);
 if not glActive then
  WaitMessage
 else
  begin
  Time       := GetTimer;
  Time_Delta := Time - Time_Old;

  flag := false;
  for i := 1 to Time_Delta div 10 do
   begin
   Game_Update;
   flag := true;
   end;

  if flag = true then
   Time_Old := Time - Time_Delta mod 10;
  Game_Render;
  end;
 end;
 
WndProc(Handle, WM_CLOSE, 0, 0);
end.
