unit l_camera;

interface

uses
 Windows, OpenGL,
 l_gl, l_math, l_player, l_input;

type
 TCamera = object
  protected
   Angle  : TVector;
  public
   Pos    : TVector;
   m      : array [0..15] of single;
   Target : PPLayer;
   procedure Init;
   procedure Update;
   procedure SetRender;
   procedure SetProj;
 end;

implementation

procedure TCamera.Init;
begin
end;

procedure TCamera.Update;
var
 A, B, C, D, E, F : single;
 cx, cy, cz       : TVector;
begin
if Target <> nil then
 begin
 Pos   := V_Add(Target^.Pos, Vector(0, 1, 0));
 Angle := Target^.Angle;
 with Target^.Angle do
  begin
  Y := Y + MDelta.X/628;
  X := min(max(X - MDelta.Y/628, -pi/2), pi/2);

  A := cos(X);
  B := sin(X);
  C := sin(Y);
  D := cos(Y);
  E := cos(Z);
  F := sin(Z);

{
// ZXY
[  E  F  0 ]   [ 1  0  0 ]   [ C  0 -D ]   [ CE+BDF AF BCF-ED ]
[ -F  E  0 ] X [ 0  A  B ] X [ 0  1  0 ] = [ BDE-CF AE DF+BCE ]
[  0  0  1 ]   [ 0 -B  A ]   [ D  0  C ]   [ AD     -B AC     ]
}

  cx := Vector(C*E+B*D*F, A*F, B*C*F-E*D);
  cy := Vector(B*D*E-C*F, A*E, D*F+B*C*E);
  cz := Vector(A*D,        -B,       A*C);

  m[0] := cx.X;  m[4] := cx.Y;  m[8]  := cx.Z;  m[12] := -V_Dot(cx, Pos);
  m[1] := cy.X;  m[5] := cy.Y;  m[9]  := cy.Z;  m[13] := -V_Dot(cy, Pos);
  m[2] := cz.X;  m[6] := cz.Y;  m[10] := cz.Z;  m[14] := -V_Dot(cz, Pos);
  m[3] := 0;     m[7] := 0;     m[11] := 0;     m[15] := 1;
  end;
 end;
end;

procedure TCamera.SetProj;
const
 zNear = 0.1;
 zFar  = 102.4;
var
 aspect : single;
begin
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
aspect := glWidth/glHeight;
//  - 90 
glFrustum(-zNear*aspect, zNear*aspect, -zNear, zNear, zNear, zFar);
glMatrixMode(GL_MODELVIEW);
glViewPort(0, 0, glWidth, glHeight);
end;

procedure TCamera.SetRender;
begin
glLoadMatrixf(@m);
end;

end.

