unit l_game;

interface

uses
 Windows, OpenGL,
 l_gl, l_math, l_input, l_utils, l_map, l_camera;

procedure Game_Init;
procedure Game_Free;
procedure Game_Render;
procedure Game_Update;

var
 Map    : TMap;
 Camera : TCamera;

implementation

procedure Game_Init;
begin
  Map.LoadFromFile('xtest3');
  Camera.Target := Map.pl_add;
  Camera.SetProj;
end;

procedure Game_Free;
begin
  Map.Clear;
end;

procedure Game_Update;
begin
  Map.Update;
  Camera.Update;
  MDelta.X := 0;
  MDelta.Y := 0;
  if Key[vk_F1] then
    Map.Mesh[0].Vertex[2].X := Map.Mesh[0].Vertex[2].X - 0.1;
end;

procedure Game_Render;
begin
  glClear(GL_DEPTH_BUFFER_BIT);
  glClear(GL_COLOR_BUFFER_BIT);

  Camera.SetRender;
  glEnable(GL_DEPTH_TEST);
  Map.Render;
  glDisable(GL_DEPTH_TEST);

  glSwap;
end;

end.

