unit l_player;

interface

uses
 l_math, l_input;

type
 TKey = record
  ID   : Byte;
  Down : boolean;
 end;

 // 
 TPlayer = object
  protected
   ang   : single;
  public
   Pos   : TVector; // 
   Angle : TVector; //  
   Speed : TVector;
   Acc   : TVector;
   Keys  : array [0..5] of TKey;
   onGround : boolean;
   procedure Init;
   procedure Render;
   procedure Update;
 end;

 PPLayer = ^TPlayer;

const
 KEY_FORW   = 0;
 KEY_BACK   = 1;
 KEY_LEFT   = 2;
 KEY_RIGHT  = 3;
 KEY_JUMP   = 4;
 KEY_FIRE   = 5;
 MaxAcc     = 0.01;
 PLAYER_RAD = 0.5;

implementation

procedure TPlayer.Init;
begin
Keys[KEY_FORW].ID  := Byte('W');
Keys[KEY_BACK].ID  := Byte('S');
Keys[KEY_LEFT].ID  := Byte('A');
Keys[KEY_RIGHT].ID := Byte('D');
Keys[KEY_JUMP].ID := Byte(' ');
Angle := Vector(0, 0, 0);
Acc   := Vector(0, 0, 0);
Speed := Vector(0, 0, 0);
end;

procedure TPlayer.Render;
begin
end;

procedure TPlayer.Update;
var
 i  : integer;
 a  : single;
 ac : single;
begin
for i := 0 to HIGH(Keys) do
 Keys[i].Down := KeyDown(Keys[i].ID);

if (Keys[KEY_FORW].Down xor Keys[KEY_BACK].Down) or
   (Keys[KEY_LEFT].Down xor Keys[KEY_RIGHT].Down) then
 ac := MaxAcc
else
 ac := 0.01; 

a := Angle.Y;
//onGround  := Speed.Y = 0;

Acc := Vector(0, Acc.Y, 0);
if onGround then
 begin
 if Keys[KEY_FORW].Down  then Acc := V_Add(Acc, Vector(-cos(a), 0, -sin(a)));
 if Keys[KEY_BACK].Down  then Acc := V_Add(Acc, Vector(cos(a), 0, sin(a)));
 if Keys[KEY_LEFT].Down  then Acc := V_Add(Acc, Vector(cos(a + pi/2), 0, sin(a + pi/2)));
 if Keys[KEY_RIGHT].Down then Acc := V_Add(Acc, Vector(cos(a - pi/2), 0, sin(a - pi/2)));
 if Keys[KEY_JUMP].Down then Speed.Y := 0.35;
 Acc.X := ac*(Acc.X) - Speed.X/10;
 Acc.Z := ac*(Acc.Z) - Speed.Z/10;
 end;

Speed := V_Add(Speed, Acc);
Pos := V_Add(Pos, Speed);

//     :)
if onGround and (V_Length(Vector(Speed.X, 0, Speed.Z)) > 0.01) then
 begin
 Angle.Z := sin(ang)*pi/180;
 ang     := ang + 0.1;
 end
else
 begin
 Angle.Z := 0;
 ang     := 0;
 end;
end;

end.
